#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 11 17:37:33 2022

@author: pouriak
"""
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns
from statsmodels.miscmodels.ordinal_model import OrderedModel
from scipy.stats import norm
#from scipy.stats import pointbiserialr as pbcorr
from sklearn.metrics import brier_score_loss as BS
#from imblearn.over_sampling import SVMSMOTE
import matplotlib as mpl
#from matplotlib import cm
#import kmm
#from sklearn import preprocessing
from bokeh.palettes import magma
#from sklearn.metrics import accuracy_score
#from sklearn.metrics import f1_score
from sklearn.metrics import top_k_accuracy_score as k_acc_score
from matplotlib.ticker import LinearLocator
import scipy.stats as st


mpl.rcParams['font.sans-serif'] = "Arial"


data=pd.read_excel('Data.xlsx',sheet_name='all')



data_arch=data[data['Story']>=8]


data_period=pd.read_excel('Data.xlsx',sheet_name='Arch')

arch=data_arch['Arch']
#story=data_arch['Story']
gamma=1.25
    
    
SDR=data_arch['SDR']
Damage=data_arch['Damage']
Y=data_arch['Label']

pd.options.mode.chained_assignment = None
for i in range(len(SDR)):
    if SDR.iloc[i]<0.01:
        Damage.iloc[i]='Negligible'
        Y.iloc[i]=0
    elif (SDR.iloc[i]>=0.01) and (SDR.iloc[i]<0.026):
        Damage.iloc[i]='Slight'
        Y.iloc[i]=1
    elif (SDR.iloc[i]>=0.026) and (SDR.iloc[i]<0.036):
        Damage.iloc[i]='Moderate'
        Y.iloc[i]=2
    elif (SDR.iloc[i]>=0.036) and (SDR.iloc[i]<0.059/gamma):
        Damage.iloc[i]='Extensive'
        Y.iloc[i]=3
    else: 
        Damage.iloc[i]='Collapse' 
        Y.iloc[i]=4

var00= 'SA_1'
var0= 'SA_avg'
var1='SA_avg'; var2='Ds'; 
var1_m='SA_avg_2'; var2_m='SA_avg_3'; var3_m='Ds'

#var4='Ds'
# DS = pd.Series(Damage, dtype="category")
Y = Y.reset_index(drop=True)
SDR = SDR.reset_index(drop=True)
X_input_org = np.log(data_arch[[var0, var00]])
X_input = pd.concat([np.log(data_arch[[var1]]),(data_arch[[var2]])],axis=1)
X_input_m = pd.concat([(data_arch[[var1_m]]),data_arch[[var2_m]],(data_arch[[var3_m]])],axis=1)



X_org = X_input_org.reset_index(drop=True)
X = X_input.reset_index(drop=True)
X_m = X_input_m.reset_index(drop=True)


#%%
a = pd.Categorical(Damage, categories=['Negligible','Slight','Moderate','Extensive','Collapse'], ordered=True)
DS = pd.Series(a)

#from sklearn.model_selection import train_test_split
from sklearn.model_selection import StratifiedKFold
skf = StratifiedKFold(n_splits=5)
all_metrics = [[]]
for train_index, test_index in skf.split(X,DS):
    
    X_train_org1,X_test_org1,DS_train_org1,DS_test_org1 = X_org.iloc[train_index],X_org.iloc[test_index],DS.iloc[train_index],DS.iloc[test_index]
    X_train1,X_test1,DS_train1,DS_test1 = X.iloc[train_index],X.iloc[test_index],DS.iloc[train_index],DS.iloc[test_index]
    X_train1_m,X_test1_m,DS_train1_m,DS_test1_m = X_m.iloc[train_index],X_m.iloc[test_index],DS.iloc[train_index],DS.iloc[test_index]

    Y_train1_m=Y[X_train1_m.index]; Y_test1_m=Y[X_test1_m.index]
    Y_train1=Y[X_train1.index]; Y_test1=Y[X_test1.index]
    Y_train_org1=Y[X_train_org1.index]; Y_test_org1=Y[X_test_org1.index]
    SDR_train1_m=SDR[X_train1_m.index]; SDR_test1_m=SDR[X_test1_m.index]
    SDR_train1=SDR[X_train1.index]; SDR_test1=SDR[X_test1.index]
    SDR_train_org1=SDR[X_train_org1.index]; SDR_test_org1=SDR[X_test_org1.index]
    
    X_train_org = X_train_org1.reset_index(drop=True); X_test_org = X_test_org1.reset_index(drop=True)
    DS_train_org = DS_train_org1.reset_index(drop=True); DS_test_org = DS_test_org1.reset_index(drop=True)
    
    X_train = X_train1.reset_index(drop=True); X_test = X_test1.reset_index(drop=True)
    DS_train = DS_train1.reset_index(drop=True); DS_test = DS_test1.reset_index(drop=True)
    
    X_train_m = X_train1_m.reset_index(drop=True); X_test_m = X_test1_m.reset_index(drop=True)
    DS_train_m = DS_train1_m.reset_index(drop=True); DS_test_m = DS_test1_m.reset_index(drop=True)
    
    Y_train_m = Y_train1_m.reset_index(drop=True); Y_test_m = Y_test1_m.reset_index(drop=True)
    Y_train = Y_train1.reset_index(drop=True); Y_test = Y_test1.reset_index(drop=True)
    Y_train_org = Y_train_org1.reset_index(drop=True); Y_test_org = Y_test_org1.reset_index(drop=True)
    SDR_train_m = SDR_train1_m.reset_index(drop=True); SDR_test_m = SDR_test1_m.reset_index(drop=True)
    SDR_train = SDR_train1.reset_index(drop=True); SDR_test = SDR_test1.reset_index(drop=True)
    SDR_train_org = SDR_train_org1.reset_index(drop=True); SDR_test_org = SDR_test_org1.reset_index(drop=True)


    mod_prob_org0 = OrderedModel(DS_train_org, X_train_org[var00], distr='probit')
    mod_prob_org = OrderedModel(DS_train_org, X_train_org[var0], distr='probit')
    mod_prob = OrderedModel(DS_train, X_train, distr='probit')
    mod_prob_m = OrderedModel(DS_train_m, X_train_m, distr='probit')
    
    res_prob_org0 = mod_prob_org0.fit(method='bfgs')
    res_prob_org = mod_prob_org.fit(method='bfgs')
    res_prob = mod_prob.fit(method='bfgs')
    res_prob_m = mod_prob_m.fit(method='bfgs')
    
    coeffs_org0 = res_prob_org0.params[:len(X_input_org[var00].transpose())]
    coeffs_org = res_prob_org.params[:len(X_input_org[var0].transpose())]
    coeffs = res_prob.params[:len(X_input.transpose())]
    coeffs_m = res_prob_m.params[:len(X_input_m.transpose())]
    print(res_prob_m.summary())


    num_of_thresholds = 4
    intcpt_org0 = mod_prob_org0.transform_threshold_params(res_prob_org0.params[-num_of_thresholds:])
    intcpt_org = mod_prob_org.transform_threshold_params(res_prob_org.params[-num_of_thresholds:])
    intcpt = mod_prob.transform_threshold_params(res_prob.params[-num_of_thresholds:])
    intcpt_m = mod_prob_m.transform_threshold_params(res_prob_m.params[-num_of_thresholds:])
    
    
    def p1_0(x1):
        #Prob_DS0: probability of observing negligible damage
        Prob_DS0 = norm.cdf(intcpt_org0[1]-x1*coeffs_org0[0])
        Prob_DS1 = norm.cdf(intcpt_org0[2]-x1*coeffs_org0[0]) - norm.cdf(intcpt_org0[1]-x1*coeffs_org0[0])
        Prob_DS2 = norm.cdf(intcpt_org0[3]-x1*coeffs_org0[0]) - norm.cdf(intcpt_org0[2]-x1*coeffs_org0[0])
        Prob_DS3 = norm.cdf(intcpt_org0[4]-x1*coeffs_org0[0]) - norm.cdf(intcpt_org0[3]-x1*coeffs_org0[0])
        Prob_DS4 = 1 - norm.cdf(intcpt_org0[4]-x1*coeffs_org0[0])
        #probability of exceedance 
        #Prob_exc_DS5 = Prob_DS5
        Prob_exc_DS4 = Prob_DS4
        Prob_exc_DS3 = Prob_DS4+Prob_DS3
        Prob_exc_DS2 = Prob_DS4+Prob_DS3+Prob_DS2
        Prob_exc_DS1 = Prob_DS4+Prob_DS3+Prob_DS2+Prob_DS1
        return [Prob_DS0, Prob_DS1, Prob_DS2, Prob_DS3, Prob_DS4], [Prob_exc_DS1, Prob_exc_DS2, Prob_exc_DS3, Prob_exc_DS4]
    
    def p1(x1):
        #Prob_DS0: probability of observing negligible damage
        Prob_DS0 = norm.cdf(intcpt_org[1]-x1*coeffs_org[0])
        Prob_DS1 = norm.cdf(intcpt_org[2]-x1*coeffs_org[0]) - norm.cdf(intcpt_org[1]-x1*coeffs_org[0])
        Prob_DS2 = norm.cdf(intcpt_org[3]-x1*coeffs_org[0]) - norm.cdf(intcpt_org[2]-x1*coeffs_org[0])
        Prob_DS3 = norm.cdf(intcpt_org[4]-x1*coeffs_org[0]) - norm.cdf(intcpt_org[3]-x1*coeffs_org[0])
        Prob_DS4 = 1 - norm.cdf(intcpt_org[4]-x1*coeffs_org[0])
        #probability of exceedance 
        #Prob_exc_DS5 = Prob_DS5
        Prob_exc_DS4 = Prob_DS4
        Prob_exc_DS3 = Prob_DS4+Prob_DS3
        Prob_exc_DS2 = Prob_DS4+Prob_DS3+Prob_DS2
        Prob_exc_DS1 = Prob_DS4+Prob_DS3+Prob_DS2+Prob_DS1
        return [Prob_DS0, Prob_DS1, Prob_DS2, Prob_DS3, Prob_DS4], [Prob_exc_DS1, Prob_exc_DS2, Prob_exc_DS3, Prob_exc_DS4]
    
    def p2(x1,x2):
    
        Prob_DS0 = norm.cdf(intcpt[1]-x1*coeffs[0]-x2*coeffs[1]) - norm.cdf(intcpt[0]-x1*coeffs[0]-x2*coeffs[1])
        Prob_DS1 = norm.cdf(intcpt[2]-x1*coeffs[0]-x2*coeffs[1]) - norm.cdf(intcpt[1]-x1*coeffs[0]-x2*coeffs[1])
        Prob_DS2 = norm.cdf(intcpt[3]-x1*coeffs[0]-x2*coeffs[1]) - norm.cdf(intcpt[2]-x1*coeffs[0]-x2*coeffs[1])
        Prob_DS3 = norm.cdf(intcpt[4]-x1*coeffs[0]-x2*coeffs[1]) - norm.cdf(intcpt[3]-x1*coeffs[0]-x2*coeffs[1])
        Prob_DS4 = norm.cdf(intcpt[5]-x1*coeffs[0]-x2*coeffs[1]) - norm.cdf(intcpt[4]-x1*coeffs[0]-x2*coeffs[1])
        #probability of exceedance 
        Prob_exc_DS4 = Prob_DS4
        Prob_exc_DS3 = Prob_DS4+Prob_DS3
        Prob_exc_DS2 = Prob_DS4+Prob_DS3+Prob_DS2
        Prob_exc_DS1 = Prob_DS4+Prob_DS3+Prob_DS2+Prob_DS1
        return [Prob_DS0, Prob_DS1, Prob_DS2, Prob_DS3, Prob_DS4], [Prob_exc_DS1, Prob_exc_DS2, Prob_exc_DS3, Prob_exc_DS4]
    
    def p3(x1,x2,x3):
    
        Prob_DS0 = norm.cdf(intcpt_m[1]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2]) - norm.cdf(intcpt_m[0]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2])
        Prob_DS1 = norm.cdf(intcpt_m[2]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2]) - norm.cdf(intcpt_m[1]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2])
        Prob_DS2 = norm.cdf(intcpt_m[3]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2]) - norm.cdf(intcpt_m[2]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2])
        Prob_DS3 = norm.cdf(intcpt_m[4]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2]) - norm.cdf(intcpt_m[3]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2])
        Prob_DS4 = norm.cdf(intcpt_m[5]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2]) - norm.cdf(intcpt_m[4]-x1*coeffs_m[0]-x2*coeffs_m[1]-x3*coeffs_m[2])
        #probability of exceedance 
        Prob_exc_DS4 = Prob_DS4
        Prob_exc_DS3 = Prob_DS4+Prob_DS3
        Prob_exc_DS2 = Prob_DS4+Prob_DS3+Prob_DS2
        Prob_exc_DS1 = Prob_DS4+Prob_DS3+Prob_DS2+Prob_DS1
        return [Prob_DS0, Prob_DS1, Prob_DS2, Prob_DS3, Prob_DS4], [Prob_exc_DS1, Prob_exc_DS2, Prob_exc_DS3, Prob_exc_DS4]
    
    
    for i in range(len(SDR)):
        if SDR.iloc[i]<0.01:
            Damage.iloc[i]='Negligible'
            Y.iloc[i]=0
        elif (SDR.iloc[i]>=0.01) and (SDR.iloc[i]<0.026):
            Damage.iloc[i]='Slight'
            Y.iloc[i]=1
        elif (SDR.iloc[i]>=0.026) and (SDR.iloc[i]<0.036):
            Damage.iloc[i]='Moderate'
            Y.iloc[i]=2
        elif (SDR.iloc[i]>=0.036) and (SDR.iloc[i]<0.059/gamma):
            Damage.iloc[i]='Extensive'
            Y.iloc[i]=3
        else: 
            Damage.iloc[i]='Collapse' 
            Y.iloc[i]=4
    
    def q(y):
        if y==0:
            p_obs=[1,0,0,0,0]
        elif y==1:
            p_obs=[0,1,0,0,0]
        elif y==2:
            p_obs=[0,0,1,0,0]
        elif y==3:
            p_obs=[0,0,0,1,0]
        else:
            p_obs=[0,0,0,0,1]
        return p_obs
    
    
    BS_array00 = np.zeros(len(X_test_org[var00]))
    BS_array0 = np.zeros(len(X_test_org[var0]))
    BS_array1 = np.zeros(len(X_test))
    BS_array2 = np.zeros(len(X_test_m))
    
    BS_array_all_m = np.zeros(len(X_m))
    BS_array_all = np.zeros(len(X))
    BS_array_all_uni = np.zeros(len(X))
    BS_array_all_uni0 = np.zeros(len(X))
    np.seterr(divide = 'ignore') 
    np.errstate(invalid='ignore')
    
    probs00=[]
    probs0=[]
    probs1=[]
    probs2=[]
    probs_obs=[]
    probs_obs_m=[]
    
        
    probs_obs_all=[]
    probs_est_all_m=[]; 
    probs_est_all=[];
    probs_est_all_uni=[];
    probs_est_all_uni0=[];
    
    
    for i in range(len(X_test)):
        p1_0_estimate = p1_0(X_test_org[var00][i])[0]
        probs00.append(p1_0_estimate)
        
        p1_estimate = p1(X_test_org[var0][i])[0]
        probs0.append(p1_estimate)
        
        p2_estimate = p2(X_test[var1][i],X_test[var2][i])[0]
        probs1.append(p2_estimate)
        
        p3_estimate = p3(X_test_m[var1_m][i],X_test_m[var2_m][i],X_test_m[var3_m][i])[0]
        probs2.append(p3_estimate)
        
        q_estimate_org = q(Y_test_org[i]) 
        q_estimate = q(Y_test[i])
        q_estimate_m = q(Y_test_m[i])
        
        probs_obs.append(q_estimate)
        probs_obs_m.append(q_estimate_m)
        
        BS_array00[i] = BS(q_estimate_org, p1_0_estimate)
        BS_array0[i] = BS(q_estimate_org, p1_estimate)
        BS_array1[i] = BS(q_estimate, p2_estimate)
        BS_array2[i] = BS(q_estimate_m, p3_estimate)
    
    BS_avg00 = np.mean(BS_array00)
    BS_avg0 = np.mean(BS_array0)
    BS_avg1 = np.mean(BS_array1)
    BS_avg2 = np.mean(BS_array2)
    
    
    #% nominal probit regression
    #import statsmodels.api as sm
    from statsmodels.discrete.discrete_model import Probit
    Y_probit4_m = Y_train_m >=4 ; Y_probit3_m = Y_train_m >=3; Y_probit2_m = Y_train_m >=2; Y_probit1_m = Y_train_m >=1; 
    Y_probit4 = Y_train >=4 ; Y_probit3 = Y_train >=3; Y_probit2 = Y_train >=2; Y_probit1 = Y_train >=1; 
    Y_probit4_org = Y_train_org >=4 ; Y_probit3_org = Y_train_org >=3; Y_probit2_org = Y_train_org >=2; Y_probit1_org = Y_train_org >=1; 
    
    
    const=pd.DataFrame(np.ones(len(X_train)))
    X_train2_m = pd.concat([X_train_m,const], axis=1)
    X_train2 = pd.concat([X_train,const], axis=1)
    X_train2_org = pd.concat([X_train_org[var0],const], axis=1)
    X_train2_org0 = pd.concat([X_train_org[var00],const], axis=1)
    
    
    model4_m = Probit(Y_probit4_m, X_train2_m); model3_m = Probit(Y_probit3_m, X_train2_m); model2_m = Probit(Y_probit2_m, X_train2_m); model1_m = Probit(Y_probit1_m, X_train2_m);
    model4 = Probit(Y_probit4, X_train2); model3 = Probit(Y_probit3, X_train2); model2 = Probit(Y_probit2, X_train2); model1 = Probit(Y_probit1, X_train2);
    model4_org = Probit(Y_probit4_org, X_train2_org); model3_org = Probit(Y_probit3_org, X_train2_org); model2_org = Probit(Y_probit2_org, X_train2_org); model1_org = Probit(Y_probit1_org, X_train2_org);
    model4_org0 = Probit(Y_probit4_org, X_train2_org0); model3_org0 = Probit(Y_probit3_org, X_train2_org0); model2_org0 = Probit(Y_probit2_org, X_train2_org0); model1_org0 = Probit(Y_probit1_org, X_train2_org0);
    
    probit_model4_m = model4_m.fit(); probit_model3_m = model3_m.fit(); probit_model2_m = model2_m.fit(); probit_model1_m = model1_m.fit(); 
    probit_model4 = model4.fit(); probit_model3 = model3.fit(); probit_model2 = model2.fit(); probit_model1 = model1.fit(); 
    probit_model4_org = model4_org.fit(); probit_model3_org = model3_org.fit(); probit_model2_org = model2_org.fit(); probit_model1_org = model1_org.fit(); 
    probit_model4_org0 = model4_org0.fit(); probit_model3_org0 = model3_org0.fit(); probit_model2_org0 = model2_org0.fit(); probit_model1_org0 = model1_org0.fit(); 
    
    
    coeff4_m=probit_model4_m.params; coeff3_m=probit_model3_m.params; coeff2_m=probit_model2_m.params; coeff1_m=probit_model1_m.params; 
    coeff4=probit_model4.params; coeff3=probit_model3.params; coeff2=probit_model2.params; coeff1=probit_model1.params; 
    coeff4_org=probit_model4_org.params; coeff3_org=probit_model3_org.params; coeff2_org=probit_model2_org.params; coeff1_org=probit_model1_org.params; 
    coeff4_org0=probit_model4_org0.params; coeff3_org0=probit_model3_org0.params; coeff2_org0=probit_model2_org0.params; coeff1_org0=probit_model1_org0.params; 
    
    def probit_uni0(x1):
        Prob_DS1 = norm.cdf(coeff1_org0[0] + x1*coeff1_org0[var00])
        Prob_DS2 = norm.cdf(coeff2_org0[0] + x1*coeff2_org0[var00])
        Prob_DS3 = norm.cdf(coeff3_org0[0] + x1*coeff3_org0[var00])
        Prob_DS4 = norm.cdf(coeff4_org0[0] + x1*coeff4_org0[var00])
        #probability of occurence 
        Prob_occ_DS0 = (1-Prob_DS1)
        Prob_occ_DS1 = (-Prob_DS2+Prob_DS1)
        Prob_occ_DS2 = (-Prob_DS3+Prob_DS2)
        Prob_occ_DS3 = (-Prob_DS4+Prob_DS3)
        Prob_occ_DS4 = (Prob_DS4)
        
        #probability of exceedance 
        Prob_exc_DS4 = Prob_occ_DS4
        Prob_exc_DS3 = Prob_occ_DS4+Prob_occ_DS3
        Prob_exc_DS2 = Prob_occ_DS4+Prob_occ_DS3+Prob_occ_DS2
        Prob_exc_DS1 = Prob_occ_DS4+Prob_occ_DS3+Prob_occ_DS2+Prob_occ_DS1
        return [abs(Prob_occ_DS0), abs(Prob_occ_DS1), abs(Prob_occ_DS2), abs(Prob_occ_DS3), abs(Prob_occ_DS4)], [Prob_exc_DS1, Prob_exc_DS2, Prob_exc_DS3, Prob_exc_DS4]
    
    def probit_uni(x1):
        Prob_DS1 = norm.cdf(coeff1_org[0] + x1*coeff1_org[var0])
        Prob_DS2 = norm.cdf(coeff2_org[0] + x1*coeff2_org[var0])
        Prob_DS3 = norm.cdf(coeff3_org[0] + x1*coeff3_org[var0])
        Prob_DS4 = norm.cdf(coeff4_org[0] + x1*coeff4_org[var0])
        #probability of occurence 
        Prob_occ_DS0 = (1-Prob_DS1)
        Prob_occ_DS1 = (-Prob_DS2+Prob_DS1)
        Prob_occ_DS2 = (-Prob_DS3+Prob_DS2)
        Prob_occ_DS3 = (-Prob_DS4+Prob_DS3)
        Prob_occ_DS4 = (Prob_DS4)
        
        #probability of exceedance 
        Prob_exc_DS4 = Prob_occ_DS4
        Prob_exc_DS3 = Prob_occ_DS4+Prob_occ_DS3
        Prob_exc_DS2 = Prob_occ_DS4+Prob_occ_DS3+Prob_occ_DS2
        Prob_exc_DS1 = Prob_occ_DS4+Prob_occ_DS3+Prob_occ_DS2+Prob_occ_DS1
        return [abs(Prob_occ_DS0), abs(Prob_occ_DS1), abs(Prob_occ_DS2), abs(Prob_occ_DS3), abs(Prob_occ_DS4)], [Prob_exc_DS1, Prob_exc_DS2, Prob_exc_DS3, Prob_exc_DS4]
    
    
    def probit2(x1,x2):
        Prob_DS1 = norm.cdf(coeff1[0] + x1*coeff1[var1] + x2*coeff1[var2])
        Prob_DS2 = norm.cdf(coeff2[0] + x1*coeff2[var1] + x2*coeff2[var2])
        Prob_DS3 = norm.cdf(coeff3[0] + x1*coeff3[var1] + x2*coeff3[var2])
        Prob_DS4 = norm.cdf(coeff4[0] + x1*coeff4[var1] + x2*coeff4[var2])
        #probability of occurence 
        Prob_occ_DS0 = (1-Prob_DS1)
        Prob_occ_DS1 = (-Prob_DS2+Prob_DS1)
        Prob_occ_DS2 = (-Prob_DS3+Prob_DS2)
        Prob_occ_DS3 = (-Prob_DS4+Prob_DS3)
        Prob_occ_DS4 = (Prob_DS4)
        #probability of exceedance 
        Prob_exc_DS4 = Prob_occ_DS4
        Prob_exc_DS3 = Prob_occ_DS4+Prob_occ_DS3
        Prob_exc_DS2 = Prob_occ_DS4+Prob_occ_DS3+Prob_occ_DS2
        Prob_exc_DS1 = Prob_occ_DS4+Prob_occ_DS3+Prob_occ_DS2+Prob_occ_DS1
        return [abs(Prob_occ_DS0), abs(Prob_occ_DS1), abs(Prob_occ_DS2), abs(Prob_occ_DS3), abs(Prob_occ_DS4)], [Prob_exc_DS1, Prob_exc_DS2, Prob_exc_DS3, Prob_exc_DS4]
    
    
    def probit3(x1,x2,x3):
        Prob_DS1 = norm.cdf(coeff1_m[0] + x1*coeff1_m[var1_m] + x2*coeff1_m[var2_m] + x3*coeff1_m[var3_m])
        Prob_DS2 = norm.cdf(coeff2_m[0] + x1*coeff2_m[var1_m] + x2*coeff2_m[var2_m] + x3*coeff2_m[var3_m])
        Prob_DS3 = norm.cdf(coeff3_m[0] + x1*coeff3_m[var1_m] + x2*coeff3_m[var2_m] + x3*coeff3_m[var3_m])
        Prob_DS4 = norm.cdf(coeff4_m[0] + x1*coeff4_m[var1_m] + x2*coeff4_m[var2_m] + x3*coeff4_m[var3_m])
        #probability of occurence 
        Prob_occ_DS0 = (1-Prob_DS1)
        Prob_occ_DS1 = (-Prob_DS2+Prob_DS1)
        Prob_occ_DS2 = (-Prob_DS3+Prob_DS2)
        Prob_occ_DS3 = (-Prob_DS4+Prob_DS3)
        Prob_occ_DS4 = (Prob_DS4)
        #probability of exceedance 
        Prob_exc_DS4 = Prob_occ_DS4
        Prob_exc_DS3 = Prob_occ_DS4+Prob_occ_DS3
        Prob_exc_DS2 = Prob_occ_DS4+Prob_occ_DS3+Prob_occ_DS2
        Prob_exc_DS1 = Prob_occ_DS4+Prob_occ_DS3+Prob_occ_DS2+Prob_occ_DS1
        return [abs(Prob_occ_DS0), abs(Prob_occ_DS1), abs(Prob_occ_DS2), abs(Prob_occ_DS3), abs(Prob_occ_DS4)], [Prob_exc_DS1, Prob_exc_DS2, Prob_exc_DS3, Prob_exc_DS4]

    
    probs_p_m=[]
    probs_p=[]
    probs_p_uni=[]
    probs_p_uni0=[]
    


#%%

loss_array = np.array([0, 0.05, 0.2, 0.6, 1])
site = ['Seattle', 'N Seattle', 'Bellevue', 'Tacoma']
#site = ['N Seattle']
EL_all = []
Pc_all = []
Pc_m_all = []
for x in site:
    #site='N Seattle'
    M9_ID=26
    
    data_all=pd.read_excel('regional_data.xlsx',sheet_name=x)
    data=data_all[data_all['ID']==M9_ID]
    data = data.reset_index(drop=True)
    
    SA_1 = np.log(data['SA_1'])
    SA_SP = data['SA_avg_SP']
    SA_LP = data['SA_avg_LP']
    SA_avg = np.log(data['SA_avg'])
    Ds = data['Ds']
    Class = data['Class']
    
    p_col_obs = len(data[data['Class']==4])/len(data)
    
    
    p_obs = []
    p_u1 = []
    p_u2 = []
    p_bn = []
    p_bo = []
    p_mn = []
    p_mo = []
    
for i in range(len(data)):
    p_obs.append(q(Class.iloc[i]))
    p_u1.append(probit_uni0(SA_1[i])[0])
    p_u2.append(probit_uni(SA_avg[i])[0])
    p_bn.append(probit2(SA_avg[i],Ds[i])[0])
    p_mn.append(probit3(SA_SP[i],SA_LP[i],Ds[i])[0])
    
    p_bo.append(p2(SA_avg[i],Ds[i])[0])
    p_mo.append(p3(SA_SP[i],SA_LP[i],Ds[i])[0])
      
  
p_col_u1 = np.mean(np.squeeze(p_u1)[:,4])
p_col_u2 = np.mean(np.squeeze(p_u2)[:,4])
p_col_bn = np.mean(np.squeeze(p_bn)[:,4])
p_col_mn = np.mean(np.squeeze(p_mn)[:,4])
p_col_bo = np.mean(np.squeeze(p_bo)[:,4])
p_col_mo = np.mean(np.squeeze(p_mo)[:,4])


EL_obs = np.mean(np.dot(np.squeeze(p_obs), loss_array))
EL_u1 = np.mean(np.dot(np.squeeze(p_u1), loss_array))
EL_u2 = np.mean(np.dot(np.squeeze(p_u2), loss_array))
EL_bn = np.mean(np.dot(np.squeeze(p_bn), loss_array))
EL_bo = np.mean(np.dot(np.squeeze(p_bo), loss_array))
EL_mn = np.mean(np.dot(np.squeeze(p_mn), loss_array))
EL_mo = np.mean(np.dot(np.squeeze(p_mo), loss_array))




#%% loss & collapse risk bar charts:

plt.rcParams["figure.figsize"] = (6,2.75)
plt.rcParams["figure.dpi"] = 300

colors = ['grey',magma(24)[23], magma(24)[20], magma(24)[16], magma(24)[13], magma(24)[4]]

df = pd.DataFrame([['Seattle']+[6.90,3.39,3.58,7.58,10.00,8.56], ['North Seattle']+[20.69,3.25,4.41,6.30,28.01,32.20], ['Bellevue']+[17.24,2.58,3.23,6.16,12.26,11.00],
                   ['Tacoma']+[3.45,2.68,2.98,6.32,5.92,3.45], ['Overall']+[12.07,2.98,3.55,6.59,14.05,13.80]],
                  columns=['Location','Observed', 'U$_{1}$', 'U$_{2}$', 'B$_{n}$', 'M$_{n}$','M$_{o}$'])
dg = df
dg.iloc[:,1:] = df.iloc[:,1:].div(100)

dg.plot(x='Location',
        kind='bar',
        stacked=False,
        width=.8,rot=0,edgecolor='black',color=colors)
plt.ylim(0,.4)
plt.xlabel('- Location -',fontsize=11)
plt.ylabel('Probability of Collapse',fontsize=11)
plt.title('Collapse Risk',fontsize=11)
plt.xticks(fontsize=11)
plt.yticks(fontsize=11)
plt.legend(fontsize=10,loc='upper right')


#####
plt.rcParams["figure.figsize"] = (6,2.75)
plt.rcParams["figure.dpi"] = 300

colors = ['grey',magma(24)[23], magma(24)[20], magma(24)[16], magma(24)[13], magma(24)[4]]

df = pd.DataFrame([['Seattle']+[0.286,0.112,0.140,0.221,0.300,0.294], ['North Seattle']+[0.455,0.107,0.162,0.203,0.515,0.549], ['Bellevue']+[0.376,0.082,0.131,0.194,0.331,0.327],
                   ['Tacoma']+[0.252,0.086,0.123,0.195,0.230,0.209], ['Overall']+[0.342,0.097,0.139,0.203,0.344,0.345]],
                  columns=['Location','Observed', 'U$_{1}$', 'U$_{2}$', 'B$_{n}$', 'M$_{n}$','M$_{o}$'])

df.plot(x='Location',
        kind='bar',
        stacked=False,
        width=.8,rot=0,edgecolor='black',color=colors,legend=None)
plt.ylim(0,.6)
plt.xlabel('- Location -',fontsize=11)
plt.ylabel('Expected Loss Ratio',fontsize=11)
plt.title('Seismic Losses',fontsize=11)
plt.xticks(fontsize=11)
plt.yticks(fontsize=11)
#plt.legend(fontsize=10,loc='best')




